# Search API MeCab

## Overview

MeCab is an open-source morphological analysis engine developed through a [京都大学情報学研究科--NTTコミュニケーション科学基礎研究所 共同研究ユニット](https://nlp.ist.i.kyoto-u.ac.jp/kuntt/)

This module provides a tokenizer that utilizes MeCab installed on the server.

## Requirements

- MeCab must be installed.
- A dictionary for MeCab must be installed.
- The `mecab` command must be executable from the web server.

## Installation

MeCab can be installed using a package manager on many environments.

### Homebrew

```bash
brew install mecab mecab-ipadic
```

### Ubuntu

```bash
apt install mecab mecab-ipadic-utf8
```

### DDEV

Add the required MeCab packages to `webimage_extra_packages` in `.ddev/config.yaml` and restart DDEV.

```yaml
webimage_extra_packages: [mecab, libmecab-dev, mecab-ipadic-utf8]
```

## Usage

Once this module is installed, **MeCab tokenizer** will appear in the list of Search API processors. Enable it to use.

This plugin is based on the traditional **Tokenizer** plugin, so some configuration options are the same. Please refer to the form descriptions for details on the additional settings.
