<?php

namespace Drupal\search_api_mecab\Form;

use Drupal\search_api_japanese_tokenizer\Form\MaTestFormBase;
use Drupal\search_api_japanese_tokenizer\MaManagerInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Defines a form for testing the MeCab integration.
 */
class MecabTestForm extends MaTestFormBase {

  /**
   * The MeCab manager.
   *
   * @var \Drupal\search_api_mecab\MecabManagerInterface
   */
  protected MaManagerInterface $maManager;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('search_api_mecab.mecab_manager'),
    );
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'mecab_test_form';
  }

  /**
   * {@inheritdoc}
   */
  protected function getProcessorId(): string {
    return 'mecab_tokenizer';
  }

  /**
   * {@inheritdoc}
   */
  protected function configureMaManager(string $config_name) {
    $settings = $this->getSearchApiProcessorSettings($config_name);
    $this->maManager
      ->setExecutableDir($settings['executable_dir'])
      ->setSystemDictionaryDir($settings['system_dictionary_dir']);
  }

}
