<?php

namespace Drupal\search_api_mecab;

use Drupal\search_api_japanese_tokenizer\MaWordInterface;

/**
 * Provides an interface defining a MeCab word.
 */
interface MecabWordInterface extends MaWordInterface {

  /**
   * Returns a base form of word.
   *
   * If the base form is not available, the surface form is returned.
   *
   * @return string
   *   Base form of word.
   */
  public function getBaseForm(): string;

  /**
   * Sets the base form of word.
   *
   * @param string $string
   *   Base form of word.
   *
   * @return static
   */
  public function setBaseForm(string $string): static;

}
