<?php

namespace Drupal\search_api_mecab\Model;

use Drupal\search_api_japanese_tokenizer\Model\MaWordBase;
use Drupal\search_api_mecab\MecabWordInterface;

/**
 * Provides extracting data using MeCab output line.
 */
class MecabWord extends MaWordBase implements MecabWordInterface {

  /**
   * Base form of word.
   */
  protected string $baseForm;

  /**
   * {@inheritdoc}
   */
  public function getBaseForm(): string {
    if ($this->baseForm == '*') {
      return $this->surface;
    }
    return $this->baseForm;
  }

  /**
   * {@inheritdoc}
   */
  public function setBaseForm(string $string): static {
    $this->baseForm = $string;
    return $this;
  }

}
