<?php

namespace Drupal\Tests\search_api_mecab\Unit\Utility;

use Drupal\search_api_mecab\Model\MecabWord;
use Drupal\search_api_mecab\Utility\MecabParser;
use PHPUnit\Framework\TestCase;

/**
 * @coversDefaultClass \Drupal\search_api_mecab\Utility\MecabParser
 */
class MecabParserTest extends TestCase {

  /**
   * @covers ::parseAnalysisOutput
   */
  public function testParseAnalysisOutput() {
    $output = <<<OUTPUT
      桃	名詞,一般,*,*,*,*,桃,モモ,モモ
      から	助詞,格助詞,一般,*,*,*,から,カラ,カラ
      生まれ	動詞,自立,*,*,一段,連用形,生まれる,ウマレ,ウマレ
      た	助動詞,*,*,*,特殊・タ,基本形,た,タ,タ
      桃太郎	名詞,固有名詞,一般,*,*,*,桃太郎,モモタロウ,モモタロー
      EOS
      OUTPUT;

    $words = (new MecabParser())->parseAnalysisOutput($output);

    $expected = [
      (new MecabWord())->setSurface('桃')->setPartOfSpeech('名詞')->setBaseForm('桃'),
      (new MecabWord())->setSurface('から')->setPartOfSpeech('助詞')->setBaseForm('から'),
      (new MecabWord())->setSurface('生まれ')->setPartOfSpeech('動詞')->setBaseForm('生まれる'),
      (new MecabWord())->setSurface('た')->setPartOfSpeech('助動詞')->setBaseForm('た'),
      (new MecabWord())->setSurface('桃太郎')->setPartOfSpeech('名詞')->setBaseForm('桃太郎'),
    ];

    $this->assertEquals($expected, $words);
  }

}
