# Search API Sudachi

## 概要

SudachiはJavaで書かれたオープンソースの日本語形態素解析器です。[ワークス徳島人工知能NLP研究所により提供されているソフトウェア](https://worksapplications.github.io/Sudachi/)の1つです。

本モジュールは、サーバー上にインストールされたSudachiを利用するトークナイザーを提供します。

## 要件

- Java Runtime Environment (JRE) がインストールされていること
- Webサーバーから`java`コマンドが実行できること
- Sudachiがインストールされていること
- Sudachiの辞書がインストールされていること

## インストール方法

インストール方法は[公式のドキュメント](https://github.com/WorksApplications/Sudachi/blob/develop/docs/tutorial.md)を参照してください。

### DDEV

DDEVで本モジュールを利用する場合は、JREのインストールとSudachiのインストールを行うためのDockerfileを作成する必要があります。

.ddev/config.yamlの`webimage_extra_packages`に`default-jre`のパッケージを追加してください。

次の内容のファイルを /.ddev/web-build/Dockerfile に設置して再起動してください。SudachiのJARファイルは`/usr/local/sudachi/sudachi-0.7.5.jar`にインストールされます。

```dockerfile
WORKDIR /tmp

RUN wget https://github.com/WorksApplications/Sudachi/releases/download/v0.7.5/sudachi-0.7.5-executable.zip \
  && wget http://sudachi.s3-website-ap-northeast-1.amazonaws.com/sudachidict/sudachi-dictionary-20241021-core.zip \
  && unzip sudachi-dictionary-20241021-core.zip

RUN unzip /tmp/sudachi-0.7.5-executable.zip -d /usr/local/sudachi \
  && mv /tmp/sudachi-dictionary-20241021/system_core.dic /usr/local/sudachi
```

## 利用方法

本モジュールをインストールすると、Search APIのプロセッサー一覧にSudachi tokenizerが表示されますので、有効化してください。

このプラグインは従来のTokenizerプラグインをベースとしているため、一部の設定項目はTokenizerプラグインの設定と同じです。追加される各設定項目の内容についてフォームの説明文を参照してください。
