# Search API Sudachi

## Overview

Sudachi is an open-source Japanese morphological analyzer written in Java. It is one of the software tools provided by the [WAP Tokushima Laboratory of AI and NLP](https://worksapplications.github.io/Sudachi/).

This module provides a tokenizer that utilizes Sudachi installed on the server.

## Requirements

- Java Runtime Environment (JRE) must be installed.
- The `java` command must be executable from the web server.
- Sudachi must be installed.
- A dictionary for Sudachi must be installed.

## Installation

Please refer to the [official documentation](https://github.com/WorksApplications/Sudachi/blob/develop/docs/tutorial.md) for installation instructions.

### DDEV

If you are using DDEV, you need to create a Dockerfile to install JRE and Sudachi.

Add the `default-jre` package to `webimage_extra_packages` in `.ddev/config.yaml`.

Create the following file at `/.ddev/web-build/Dockerfile` and restart DDEV.
Sudachi's JAR file will be installed at `/usr/local/sudachi/sudachi-0.7.5.jar`.

```dockerfile
WORKDIR /tmp

RUN wget https://github.com/WorksApplications/Sudachi/releases/download/v0.7.5/sudachi-0.7.5-executable.zip \
  && wget http://sudachi.s3-website-ap-northeast-1.amazonaws.com/sudachidict/sudachi-dictionary-20241021-core.zip \
  && unzip sudachi-dictionary-20241021-core.zip

RUN unzip /tmp/sudachi-0.7.5-executable.zip -d /usr/local/sudachi \
  && mv /tmp/sudachi-dictionary-20241021/system_core.dic /usr/local/sudachi
```

## Usage

Once this module is installed, **Sudachi tokenizer** will appear in the list of Search API processors. Enable it to use.

This plugin is based on the traditional **Tokenizer** plugin, so some configuration options are the same. Please refer to the form descriptions for details on the additional settings.
