<?php

namespace Drupal\search_api_sudachi\Form;

use Drupal\search_api_japanese_tokenizer\Form\MaTestFormBase;
use Drupal\search_api_japanese_tokenizer\MaManagerInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Defines a form for testing the Sudachi integration.
 */
class SudachiTestForm extends MaTestFormBase {

  /**
   * The Sudachi manager.
   *
   * @var \Drupal\search_api_sudachi\SudachiManagerInterface
   */
  protected MaManagerInterface $maManager;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('search_api_sudachi.sudachi_manager'),
    );
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'sudachi_test_form';
  }

  /**
   * {@inheritdoc}
   */
  protected function getProcessorId(): string {
    return 'sudachi_tokenizer';
  }

  /**
   * {@inheritdoc}
   */
  protected function configureMaManager(string $config_name) {
    $settings = $this->getSearchApiProcessorSettings($config_name);
    $this->maManager
      ->setJarPath($settings['jar_path'])
      ->setSettingsFilePath($settings['settings_file_path'])
      ->setSystemDictionaryPath($settings['system_dictionary_path'])
      ->setSplitMode($settings['split_mode']);
  }

}
