<?php

namespace Drupal\search_api_sudachi;

use Drupal\search_api_japanese_tokenizer\MaWordInterface;

/**
 * Provides an interface defining a Sudachi word.
 */
interface SudachiWordInterface extends MaWordInterface {

  /**
   * Returns a normalized word.
   *
   * @return string
   *   Normalized word.
   */
  public function getNormalizedWord(): string;

  /**
   * Sets the normalized word.
   *
   * @param string $string
   *   Normalized word.
   *
   * @return static
   *   This object.
   */
  public function setNormalizedWord(string $string): static;

}
