<?php

namespace Drupal\Tests\search_api_sudachi\Unit\Utility;

use Drupal\search_api_sudachi\Model\SudachiWord;
use Drupal\search_api_sudachi\Utility\SudachiParser;
use PHPUnit\Framework\TestCase;

/**
 * @coversDefaultClass \Drupal\search_api_sudachi\Utility\SudachiParser
 */
class SudachiParserTest extends TestCase {

  /**
   * @covers ::parseAnalysisOutput
   */
  public function testParseAnalysisOutput() {
    $output = <<<OUTPUT
      桃	名詞,普通名詞,一般,*,*,*	桃
      から	助詞,格助詞,*,*,*,*	から
      生まれ	動詞,一般,*,*,下一段-ラ行,連用形-一般	生まれる
      た	助動詞,*,*,*,助動詞-タ,連体形-一般	た
      桃太郎	名詞,固有名詞,人名,名,*,*	桃太郎
      EOS
      OUTPUT;
    $words = (new SudachiParser())->parseAnalysisOutput($output);

    $expected = [
      (new SudachiWord())->setSurface('桃')->setPartOfSpeech('名詞')->setNormalizedWord('桃'),
      (new SudachiWord())->setSurface('から')->setPartOfSpeech('助詞')->setNormalizedWord('から'),
      (new SudachiWord())->setSurface('生まれ')->setPartOfSpeech('動詞')->setNormalizedWord('生まれる'),
      (new SudachiWord())->setSurface('た')->setPartOfSpeech('助動詞')->setNormalizedWord('た'),
      (new SudachiWord())->setSurface('桃太郎')->setPartOfSpeech('名詞')->setNormalizedWord('桃太郎'),
    ];

    $this->assertEquals($expected, $words);
  }

}
