# Search API TinySegmenter

## 概要

[TinySegmenter]は、Taku Kudo氏が開発した日本語の分かち書きを行うトークナイザーです。JavaScriptで実装されており、機械学習のみを用いて単語の分割を行います。

本モジュールは、PHPに移植された[TinySegmenter PHP]を利用しています。サーバー上に別途アプリケーションをインストールする必要がないため、比較的手軽に導入できます。

## インストール

本モジュールは、外部のPHPライブラリ[TinySegmenter PHP]に依存しています。Composerで本モジュールをインストールすると、このライブラリも自動的にインストールされます。それ以外の方法で本モジュールをインストールする場合は、Composerを使って手動でライブラリをインストールしてください。

```bash
composer require u7aro/tinysegmenter-php
```

## 利用方法

本モジュールをインストールすると、Search APIのプロセッサー一覧にTinySegmenter tokenizerが表示されますので、有効化してください。

このプラグインは従来のTokenizerプラグインをベースとしているため、一部の設定項目はTokenizerプラグインの設定と同じです。追加される各設定項目の内容についてフォームの説明文を参照してください。

本モジュールではひらがな・カタカナ・漢字・その他の文字種ごとにインデックス付けをする単語の最小文字数を設定することができます。ひらがなやカタカナは2文字未満の単語に意味があるものが少ないため、2〜3文字程度にすることをお勧めします。一方で漢字は1文字でも意味がある単語が多いため、1文字に設定することをお勧めします。

ここで設定した文字数は、対象の単語がいずれかの条件を満たしていればインデックス付けされます。例えば漢字を3文字、ひらがなを2文字に設定した場合、「その他」と言う単語はひらがなの条件を満たすためインデックス付けされます。

[TinySegmenter]: http://chasen.org/~taku/software/TinySegmenter/
[TinySegmenter PHP]: https://github.com/u7aro/tinysegmenter-php
