# Search API TinySegmenter

## Overview

[TinySegmenter] is a Japanese tokenizer developed by Taku Kudo. It is implemented in JavaScript and performs word segmentation using machine learning techniques.

This module utilizes [TinySegmenter PHP], a PHP port of [TinySegmenter]. Since it does not require installing additional applications on the server, it is relatively easy to set up.

## Installation

This module depends on the external PHP library [TinySegmenter PHP]. When installing this module via Composer, the required library will be automatically installed. If you need to install the library manually, use the following command:

```bash
composer require u7aro/tinysegmenter-php
```

## Usage

Once this module is installed, "TinySegmenter tokenizer" will appear in the list of Search API processors. Please enable it to use the tokenizer.

Since this plugin is based on the existing Tokenizer plugin, some of its settings are the same. For details on additional settings, please refer to the descriptions provided in the configuration form.

This module allows you to set the minimum character count required for indexing words based on different character types: hiragana, katakana, kanji, and others. Since words consisting of less than two hiragana or katakana characters often lack meaning, it is recommended to set the minimum length to 2 or 3 characters. In contrast, kanji characters frequently hold meaning individually, so a minimum length of 1 character is recommended.

A word will be indexed if it meets at least one of the specified minimum character count conditions. For example, if the minimum length for kanji is set to 3 and for hiragana is set to 2, the word "そのため" ("sonotame") will be indexed because it meets the hiragana condition.

[TinySegmenter]: http://chasen.org/~taku/software/TinySegmenter/
[TinySegmenter PHP]: https://github.com/u7aro/tinysegmenter-php
