<?php

namespace Drupal\search_api_japanese_tokenizer;

/**
 * Provides an interface defining a morphological analysis word.
 */
interface MaWordInterface {

  /**
   * Returns a surface of word.
   *
   * @return string
   *   Surface of word.
   */
  public function getSurface(): string;

  /**
   * Sets the surface of word.
   *
   * @param string $string
   *   Surface of word.
   *
   * @return static
   *   This object.
   */
  public function setSurface(string $string): static;

  /**
   * Returns a part of speech.
   *
   * @return string
   *   Part of speech.
   */
  public function getPartOfSpeech(): string;

  /**
   * Sets the part of speech.
   *
   * @param string $string
   *   Part of speech.
   *
   * @return static
   *   This object.
   */
  public function setPartOfSpeech(string $string): static;

}
