<?php

namespace Drupal\search_api_japanese_tokenizer\Model;

use Drupal\search_api_japanese_tokenizer\MaWordInterface;

/**
 * Provides extracting data using Sudachi output line..
 */
abstract class MaWordBase implements MaWordInterface {

  /**
   * Surface of word.
   */
  protected string $surface;

  /**
   * Part of speech.
   */
  protected string $partOfSpeech;

  /**
   * {@inheritdoc}
   */
  public function getSurface(): string {
    return $this->surface;
  }

  /**
   * {@inheritdoc}
   */
  public function setSurface(string $string): static {
    $this->surface = $string;
    return $this;
  }

  /**
   * {@inheritdoc}
   */
  public function getPartOfSpeech(): string {
    return $this->partOfSpeech;
  }

  /**
   * {@inheritdoc}
   */
  public function setPartOfSpeech(string $string): static {
    $this->partOfSpeech = $string;
    return $this;
  }

}
